include \masm32\include\masm32rt.inc

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
InstallTrayIcon proto

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;|                             Data                              |
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.data

	; string resources
	WinClass			db "ZWin",0
	UCBClass			db "TFormVTerm",0
	ToolTip				db "UC for Business Desktop",0
	ExitMenu			db "E&xit",0
	ShowMenu			db "&Show UCB Desktop",0
	HideMenu			db "&Hide UCB Desktop",0
	MsgBoxTitle			db "UCBTray",0
	PrevInstanceError	db "UCBTray is already running. This instance will now exit.",0
	UCBNotFoundError	db "Could not find the UC for Business Desktop window. Please start it and then re-run UCBTray.",0
	RegisterClassError	db "An error occurred while registering the window class. This instance will now exit.",0
	CreateWindowError	db "Could not create main window. This instance will now exit.",0

	; flags
	UCBState			BYTE 0

.data?
	hInstance			HINSTANCE ?
	CommandLine			LPSTR ?
	AppHwnd				HWND ?
	UCBHwnd				HWND ?
	PopupMenu			HMENU ?
	NotifyIcon			NOTIFYICONDATA <?>

.const
	MY_TRAYICON			equ 700
	MY_TRAYID			equ 701

	APP_ICON			equ 500

	EXIT_MENU			equ 100
	SHOWHIDE_MENU		equ 200

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;|                   Program Entry Point                         |
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.code
start:
	invoke				GetModuleHandle,NULL
	mov					hInstance,eax
	invoke				GetCommandLine
	mov					CommandLine,eax
	invoke				WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke				ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL				wc:WNDCLASSEX
	LOCAL				msg:MSG
	LOCAL				hwnd:HWND
	call ClearLocVars	; set all local variables to zero
	
	; quit if already running
	if 0
	invoke				FindWindowEx,NULL,NULL,ADDR WinClass,NULL
	.IF					(eax!=0)
		invoke			MessageBox,NULL,ADDR PrevInstanceError,ADDR MsgBoxTitle,MB_OK or MB_ICONERROR
		invoke			ExitProcess,eax
	.ENDIF

	; quit if there is no UCB Desktop window
	invoke				FindWindowEx,NULL,NULL,ADDR UCBClass,NULL
	mov					UCBHwnd,eax
	.IF					0 ;(eax==0)
		invoke			MessageBox,NULL,ADDR UCBNotFoundError,ADDR MsgBoxTitle,MB_OK or MB_ICONERROR
		invoke			ExitProcess,eax
	.ENDIF
	endif
	; register our class so we can create our main window
	mov					wc.cbSize,SIZEOF WNDCLASSEX
	mov					wc.style,CS_HREDRAW or CS_VREDRAW
	mov					wc.lpfnWndProc,OFFSET WndProc
	mov					wc.cbClsExtra,NULL
	mov					wc.cbWndExtra,NULL
	push				hInstance
	pop					wc.hInstance
	mov					wc.hbrBackground,COLOR_WINDOW+1
	mov					wc.lpszMenuName,NULL
	mov					wc.lpszClassName,OFFSET WinClass
	invoke				LoadIcon,NULL,IDI_APPLICATION
	mov					wc.hIcon,eax
	mov					wc.hIconSm,eax
	invoke				LoadCursor,NULL,IDC_ARROW
	mov					wc.hCursor,eax
	
	invoke				RegisterClassEx,addr wc
	.IF					(eax==0)
		invoke			MessageBox,NULL,ADDR RegisterClassError,ADDR MsgBoxTitle,MB_OK or MB_ICONERROR
		invoke			ExitProcess,eax
	.ENDIF
	invoke				CreateWindowEx,0,ADDR WinClass,0,WS_OVERLAPPEDWINDOW or WS_VISIBLE,
	CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
	NULL,NULL,hInst,NULL
	mov					AppHwnd,eax

	.IF					(eax==0)
;		MsgBox 0, LastError$(), "Hi", MB_OK
		invoke			MessageBox,NULL,ADDR CreateWindowError,ADDR MsgBoxTitle,MB_OK or MB_ICONERROR
		invoke			ExitProcess,eax
	.ENDIF

	; main message dispatch loop
	.WHILE				TRUE
		invoke			GetMessage,ADDR msg,NULL,NULL,NULL
		.BREAK .IF		(!eax)
		invoke			TranslateMessage,ADDR msg
		invoke			DispatchMessage,ADDR msg
	.ENDW

	mov					eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL				pt:POINT

	.IF					uMsg==WM_CREATE
		invoke			InstallTrayIcon
		mov				UCBState,0
		
	.ELSEIF				uMsg==WM_DESTROY
		invoke			Shell_NotifyIcon,NIM_DELETE,ADDR NotifyIcon
		invoke			PostQuitMessage,NULL

	.ELSEIF				uMsg==WM_COMMAND
		mov				eax,wParam

		.IF				ax==EXIT_MENU
			invoke		Shell_NotifyIcon,NIM_DELETE,ADDR NotifyIcon
			invoke		PostQuitMessage,NULL

		.ELSEIF			ax==SHOWHIDE_MENU
			.IF			UCBState==0		; UCB window is visible
				invoke	ModifyMenu,PopupMenu,SHOWHIDE_MENU,MF_STRING,SHOWHIDE_MENU,ADDR ShowMenu
				invoke	ShowWindow,UCBHwnd,SW_HIDE
				mov		UCBState,1

			.ELSEIF		UCBState==1		; UCB window is hidden
				invoke	ModifyMenu,PopupMenu,SHOWHIDE_MENU,MF_STRING,SHOWHIDE_MENU,ADDR HideMenu
				invoke	ShowWindow,UCBHwnd,SW_SHOW
				mov		UCBState,0
			.ENDIF
		.ENDIF

	.ELSEIF				uMsg==MY_TRAYICON
		.IF				wParam==MY_TRAYID
			.IF			lParam==WM_RBUTTONDOWN
				invoke	GetCursorPos,ADDR pt
				invoke	SetForegroundWindow,AppHwnd
				invoke	TrackPopupMenu,PopupMenu,TPM_RIGHTALIGN,pt.x,pt.y,NULL,AppHwnd,NULL
			.ENDIF
		.ENDIF
	.ENDIF
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam
;	xor eax,eax
	ret
WndProc endp

InstallTrayIcon proc
	invoke				CreatePopupMenu
	mov					PopupMenu,eax

	invoke				AppendMenu,PopupMenu,MF_STRING,SHOWHIDE_MENU,ADDR HideMenu
	invoke				AppendMenu,PopupMenu,MF_SEPARATOR,NULL,NULL
	invoke				AppendMenu,PopupMenu,MF_STRING,EXIT_MENU,ADDR ExitMenu

	mov					NotifyIcon.cbSize,SIZEOF NotifyIcon
	push				AppHwnd
	pop					NotifyIcon.hwnd
	mov					NotifyIcon.uID,MY_TRAYID
	mov					NotifyIcon.uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
	mov					NotifyIcon.uCallbackMessage,MY_TRAYICON
	invoke				LoadIcon,hInstance,APP_ICON
	mov					NotifyIcon.hIcon,eax

	mov					ecx,SIZEOF ToolTip
	lea					esi,ToolTip
	lea					edi,NotifyIcon.szTip
	.WHILE				ecx>0
		mov				eax,[esi]
		mov				[edi],eax
		inc				esi
		inc				edi
		dec				ecx
	.ENDW

	invoke				Shell_NotifyIcon,NIM_ADD,ADDR NotifyIcon

	xor					eax,eax
	ret
InstallTrayIcon endp
ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp

end start
OPT_Res	rsrc
OPT_Tmp2asm	1
